


private var enemyGeneratorScript : enemyGenerator;

var escapingMaterial : Material;
var normalMaterial : Material;
var crazinessMaterial : Material;

var amIFood : boolean = false;
private var characterRefrence : Transform;
private var trail : TrailRenderer;
private var onInstantiateCharacterScale : float;
private var mainScale : float = .5;
var whatKindOfEnemyAmI : int;
var walkingSpeed : float;

private var enemyRotationVector : Vector3;
private var enemyRotationAngle : float;

private var amIEnemy : boolean = false;

var depthOfFear : float = .75;
private var ifReadyForFear : boolean = false;;

function Awake()
{
	enemyGeneratorScript = GameObject.Find("character").GetComponent.<enemyGenerator>();
	characterRefrence = GameObject.Find("character").transform;
	onInstantiateCharacterScale = characterRefrence.localScale.x;
	
	trail = this.GetComponent.<TrailRenderer>();
	trail.startWidth = this.transform.localScale.x;
	trail.enabled = false;
}

function Start()
{
	
	walkingSpeed  = Mathf.Pow( this.transform.localScale.x/mainScale  , .35) * walkingSpeed;
}

function rotation()
{
	//this.transform.LookAt(characterRefrence);
	
	enemyRotationVector = characterRefrence.transform.position - this.transform.position;
	if(enemyRotationVector.y >= 0)
	{
		enemyRotationAngle = Vector3.Angle(enemyRotationVector , Vector3(1,0,0));
	}
	else
	{
		enemyRotationAngle  =360 -  Vector3.Angle(enemyRotationVector , Vector3(1,0,0));
	}
	this.transform.rotation.eulerAngles.z = enemyRotationAngle+90 ;
}

function Update()
{
	if(ifReadyForFear)
	{
		if( (this.transform.position.x > 70) || (this.transform.position.x < -70) || (this.transform.position.y > 30) || (this.transform.position.y > -30) )
		{
			//Destroy(this.gameObject);
		}
		if((this.transform.position.x > 60))
		{
			Destroy(this.gameObject);
		}
		
		
		if( ( this.transform.position.x < -60) )
		{
			Destroy(this.gameObject);
		}
		
		
		if(( this.transform.position.y < -30) )
		{
			Destroy(this.gameObject);
		}
		
		
		if( (this.transform.position.y > 30) )
		{
			Destroy(this.gameObject);
		}
	}
	trail.startWidth = this.transform.localScale.x;
	rotation();
	if( whatKindOfEnemyAmI == 0 )
	{
		
		if( characterRefrence.localScale.x <= onInstantiateCharacterScale )
		//if(true)
		{
			this.transform.position += ( (characterRefrence.position - this.transform.position).normalized * walkingSpeed );
		}
		else
		{
			if(this.transform.position.magnitude < 17)
			{
				this.transform.position -= ( (characterRefrence.position - this.transform.position).normalized * walkingSpeed );
			}
			else
			{
				//Destroy(this.gameObject);
			}
		}
	}
	else
	{
		this.transform.position += ( (characterRefrence.position - this.transform.position).normalized * walkingSpeed );
	}
	
	if(amIEnemy)
	{
		if( (this.transform.position - characterRefrence.transform.position).magnitude < depthOfFear)
		{
			ifReadyForFear = true;
		}
	}
	
	
}



function OnTriggerEnter(coll : Collider)
{
	if(!amIFood)
	{
		if( coll.tag=="crazinessField" )
		{
			this.renderer.material = crazinessMaterial;
			
			//enemyManagerScript = true;
			trail.enabled = true;
			
			this.tag = "enemy";
			amIEnemy  = true;
		}
	}
}

function OnTriggerExit(coll : Collider)
{
	if(!amIFood)
	{
		if( coll.tag=="crazinessField" )
		{
			this.renderer.material = normalMaterial;
			
			//enemyManagerScript = false;
			trail.enabled = false;
			
			this.tag = "friend";
			amIEnemy  = false;
			
			if(ifReadyForFear)
			{
				walkingSpeed *= -1.5;
				enemyGeneratorScript.peopleSntences_R( this.gameObject );
				
				this.renderer.material= escapingMaterial ;
				normalMaterial = escapingMaterial;
			}
			
		}
	}
}